<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractListAction.class.php';

/**
 * Sd_Learned_costumeListAction
**/
class Sd_Learned_costumeListAction extends Sd_AbstractListAction
{
    /**
     * &_getHandler
     * 
     * @param   void
     * 
     * @return  Sd_Learned_costumeHandler
     * 
     * @protected
    **/
    function &_getHandler()
    {
        $handler =& $this->mAsset->getObject('handler', 'learned_costume');
        return $handler;
    }

    /**
     * &_getFilterForm
     * 
     * @param   void
     * 
     * @return  Sd_Learned_costumeFilterForm
     * 
     * @protected
    **/
    function &_getFilterForm()
    {
        // $filter =& new Sd_Learned_costumeFilterForm();
        $filter =& $this->mAsset->getObject('filter', 'learned_costume',false);
        $filter->prepare($this->_getPageNavi(), $this->_getHandler());
        return $filter;
    }

    /**
     * _getBaseUrl
     * 
     * @param   void
     * 
     * @return  string
     * 
     * @protected
    **/
    function _getBaseUrl()
    {
        return './index.php?action=Learned_costumeList';
    }

    /**
     * getDefaultView
     * 
     * @param   void
     * 
     * @return  Enum
    **/
    public function getDefaultView()
    {
        $this->mFilter =& $this->_getFilterForm();
        $this->mFilter->fetch();
        
        $handler =& $this->_getHandler();
        $this->mObjects =& $handler->getLearningChars($this->mFilter->getCriteria());
        
        return SD_FRAME_VIEW_INDEX;
    }

    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewIndex(&$render)
    {
        $render->setTemplateName($this->mAsset->mDirname . '_learned_costume_list.html');
        #cubson::lazy_load_array('learned_costume', $this->mObjects);
        $render->setAttribute('objects', $this->mObjects);
        $render->setAttribute('pageNavi', $this->mFilter->mNavi);
        
        $costumeHandler =& $this->mAsset->getObject('handler','costume');
        $cri = new Criteria(1,1);
        $cri->setSort('costume_id','asc');
        $render->setAttribute('costumeList',$costumeHandler->getObjects($cri));
    }
}

?>
