<?php
/**
 * @file
 * @package 
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit();
}


/**
 * @class   Sd_MapViewAction
**/
class Sd_MapViewAction extends Sd_AbstractAction
{
    /**
     * @brief   Sd_MapSpotCollection
    **/
    protected $_mMapSpotCollection = null;
    
    /**
     * prepare
     * 
     * @param   void
     * 
     * @return  bool
    **/
    public function prepare()
    {
        if(!parent::prepare())
        {
            return false;
        }
        
        return true;
    }
    
    /**
     * getDefaultView
     * 
     * @param   void
     * 
     * @return  Enum
    **/
    public function getDefaultView()
    {
        if(intval($updateTime = $this->mRoot->mContext->mRequest->getRequest('update_time')) == null)
        {
            $updateTime = 999999;
        }
        
        $handler =& $this->mAsset->getObject('handler', 'map');
        $this->_mMapSpotCollection = $handler->getMapSpotCollection($updateTime);
        
        return SD_FRAME_VIEW_INDEX;
    }
    
    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
    **/
    public function executeViewIndex(/*** XCube_RenderTarget ***/ &$render)
    {
        $render->setTemplateName($this->mAsset->mDirname . '_map_view.html');
        
        $render->setAttribute('map',$this->_mMapSpotCollection);
        $render->setAttribute('updateHandler',$this->mAsset->getObject('handler','update'));
    }
}

?>
