<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_AbilityObject
**/
class Sd_AbilityObject extends XoopsSimpleObject
{
    /**
     * Sd_AbilityObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_AbilityObject()
    {
        $this->initVar('ability_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('ability_name', XOBJ_DTYPE_STRING, '', false, 50);
        $this->initVar('description', XOBJ_DTYPE_STRING, '', false, 255);
        $this->initVar('ability_cost', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_lv', XOBJ_DTYPE_INT, '', false);
        $this->initVar('regist_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_AbilityHandler
**/
class Sd_AbilityHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_ability';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'ability_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_AbilityObject';

    /**
     * Sd_AbilityHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_AbilityHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByName
     * 
     * @param   string  $name
     * 
     * @return  Sd_AbilityObject
    **/
    public function getByName(/*** string ***/ $name)
    {
        $cri = new Criteria('ability_name',$name);
        
        $ret = $this->getObjects($cri);
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
