<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Active_abilityObject
**/
class Sd_Active_abilityObject extends XoopsSimpleObject
{
    /**
     * Sd_Active_abilityObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Active_abilityObject()
    {
        $this->initVar('eno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('slot', XOBJ_DTYPE_INT, '', false);
        $this->initVar('ability_id', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_ActiveAbilityObject
**/
class Sd_ActiveAbilityObject extends XoopsSimpleObject
{
    /**
     * Sd_ActiveAbilityObject
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function Sd_ActiveAbilityObject()
    {
        $this->initVar('eno',XOBJ_DTYPE_INT);
        $this->initVar('name',XOBJ_DTYPE_STRING);
        $this->initVar('slot1',XOBJ_DTYPE_STRING);
        $this->initVar('slot2',XOBJ_DTYPE_STRING);
        $this->initVar('slot3',XOBJ_DTYPE_STRING);
        $this->initVar('slot4',XOBJ_DTYPE_STRING);
        $this->initVar('slot5',XOBJ_DTYPE_STRING);
    }
}


/**
 * Sd_Active_abilityHandler
**/
class Sd_Active_abilityHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_active_ability';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'eno';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Active_abilityObject';

    /**
     * @brief   string
    **/
    protected $_mCharTable = '{dirname}_char';
    
    /**
     * @brief   string
    **/
    protected $_mNameTable = '{dirname}_ability';

    /**
     * Sd_Active_abilityHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Active_abilityHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
        
        $this->_mCharTable = $this->db->prefix(str_replace('{dirname}',$dirname,$this->_mCharTable));
        $this->_mNameTable = $this->db->prefix(str_replace('{dirname}',$dirname,$this->_mNameTable));
    }
    
    /**
     * escapeString
     * 
     * @param   string  $str
     * 
     * @return  string
    **/
    protected function escapeString(/*** string ***/ $str)
    {
        return mysql_real_escape_string($str,$this->db->conn);
    }
    
    /**
     * &getEquipChars
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  Sd_ActiveAbilityObject[]
    **/
    public function &getEquipChars(CriteriaElement $cri)
    {
        $ret = array();
        $sqlBase = 'select distinct `c`.`eno` as eno,`c`.`full_name` as name,{0} from `{1}` as c {2} where {3} order by `c`.`eno` asc';
        $columns = array();
        $tables = array();
        $where = array();
        
        for($i = 1;$i <= 5;$i++)
        {
            $columns[] = XCube_Utils::formatString('`a{0}`.`ability_name` as `slot{0}`',$i);
            $tables[] = XCube_Utils::formatString(
                'left join `{0}` as s{1} on `c`.`eno` = `s{1}`.`eno` and `s{1}`.`slot` = {1} '
              . 'left join `{2}` as a{1} on `a{1}`.`ability_id` = `s{1}`.`ability_id`',
                $this->mTable,$i,$this->_mNameTable
            );
        }
        
        for($i = 0;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $tables[] = XCube_Utils::formatString(
                'left join `{0}` as w{1} on `c`.`eno` = `w{1}`.`eno` '
              . 'left join `{2}` as n{1} on `n{1}`.`ability_id` = `w{1}`.`ability_id`',
                $this->mTable,$i,$this->_mNameTable
            );
            $where[] = XCube_Utils::formatString(
                "`n{0}`.`ability_name` like '{1}%'",
                $i,$this->escapeString($c->getValue())
            );
        }
        
        $sql = XCube_Utils::formatString($sqlBase,implode(',',$columns),$this->_mCharTable,implode(' ',$tables),implode(' and ',$where));
        
        if($res = $this->db->query($sql,$cri->getLimit(),$cri->getStart()))
        {
            while($row = $this->db->fetchArray($res))
            {
                $obj = new Sd_ActiveAbilityObject();
                $obj->setVars($row);
                $ret[] =& $obj;
                unset($obj);
            }
        }
        
        return $ret;
    }
    
    /**
     * getEquipCharsCount
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  int
    **/
    public function getEquipCharsCount(CriteriaElement $cri)
    {
        $c = $cri->getChildElement(0);
        $sql = XCube_Utils::formatString(
            'select count(distinct `w0`.`eno`) as c from `{0}` as w0 '
          . 'left join `{1}` as n0 on `n0`.`ability_id` = `w0`.`ability_id` ',
            $this->mTable,$this->_mNameTable
        );
        $where = "`n0`.`ability_name` like '" . $this->escapeString($c->getValue()) . "%' ";
        
        for($i = 1;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $sql .= XCube_Utils::formatString(
                'left join `{0}` as w{1} on `w0`.`eno` = `w{1}`.`eno` '
              . 'left join `{2}` as n{1} on `n{1}`.`ability_id` = `w{1}`.`ability_id` ',
              $this->mTable,$i,$this->_mNameTable
            );
            $where .= XCube_Utils::formatString(
                "and `n{0}`.`ability_name` like '{1}%' ",
                $i,$this->escapeString($c->getValue())
            );
        }
        
        if($res = $this->db->query($sql . 'where ' . $where))
        {
            $row = $this->db->fetchArray($res);
            
            return $row['c'];
        }
        
        return null;
    }
}

?>
