<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_CostumeObject
**/
class Sd_CostumeObject extends XoopsSimpleObject
{
    /**
     * Sd_CostumeObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_CostumeObject()
    {
        $this->initVar('costume_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_name', XOBJ_DTYPE_STRING, '', false, 50);
        $this->initVar('grow_life', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_soul', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_pow', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_str', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_dex', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_speed', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_mag', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_reg', XOBJ_DTYPE_INT, '', false);
        $this->initVar('grow_con', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_hp', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_tp', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_at', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_df', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_mat', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_mdf', XOBJ_DTYPE_INT, '', false);
        $this->initVar('modify_act', XOBJ_DTYPE_INT, '', false);
        $this->initVar('move_cost', XOBJ_DTYPE_INT, '', false);
        $this->initVar('regist_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_CostumeHandler
**/
class Sd_CostumeHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_costume';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'costume_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_CostumeObject';

    /**
     * Sd_CostumeHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_CostumeHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * convertToData
     * 
     * @param   string  $name
     * 
     * @return  int
    **/
    public function convertToData(/*** string ***/ $name)
    {
        static $arr = array();
        
        if(isset($arr[$name]))
        {
            return $arr[$name];
        }
        
        $cri = new Criteria('costume_name',$name);
        $obj = $this->getObjects($cri);
        
        if(is_array($obj) && count($obj) == 1)
        {
            $arr[$name] = $obj[0]->get('costume_id');
            return $arr[$name];
        }
        
        return null;
    }
}

?>
