<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_DropObject
**/
class Sd_DropObject extends XoopsSimpleObject
{
    /**
     * Sd_DropObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_DropObject()
    {
        $this->initVar('drop_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('drop_name', XOBJ_DTYPE_STRING, '', true, 50);
        $this->initVar('seed', XOBJ_DTYPE_INT, '', false);
        $this->initVar('lv', XOBJ_DTYPE_INT, '', false);
        $this->initVar('element', XOBJ_DTYPE_INT, '', false);
        $this->initVar('gift', XOBJ_DTYPE_STRING, '', false, 50);
        $this->initVar('regist_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_DropHandler
**/
class Sd_DropHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_drop';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'drop_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_DropObject';

    /**
     * Sd_DropHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_DropHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByUnique
     * 
     * @param   string  $name
     * @param   int     $lv
     * @param   string  $gift
     * 
     * @return  Sd_DropObject
    **/
    public function getByUnique(/*** string ***/ $name,/*** int ***/ $lv,/*** string ***/ $gift)
    {
        $cri = new CriteriaCompo(new Criteria('drop_name',$name));
        $cri->add(new Criteria('lv',$lv));
        $cri->add(new Criteria('gift',$gift));
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
