<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Drop_seedObject
**/
class Sd_Drop_seedObject extends XoopsSimpleObject
{
    /**
     * Sd_Drop_seedObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Drop_seedObject()
    {
        $this->initVar('drop_seed_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('drop_seed_name', XOBJ_DTYPE_STRING, '', false, 255);
    }
}

/**
 * Sd_Drop_seedHandler
**/
class Sd_Drop_seedHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_drop_seed';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'drop_seed_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Drop_seedObject';

    /**
     * Sd_Drop_seedHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Drop_seedHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByName
     * 
     * @param   string  $name
     * 
     * @return  Sd_Drop_seedObject
    **/
    public function getByName(/*** string ***/ $name)
    {
        $cri = new Criteria('drop_seed_name',$name);
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
    
    /**
     * convertToView
     * 
     * @param   int $key
     * 
     * @return  string
    **/
    public function convertToView(/*** int ***/ $key)
    {
        static $cache = null;
        
        if($cache == null)
        {
            $cache = $this->getObjects(null,null,null,true);
        }
        
        return isset($cache[$key]) ? $cache[$key]->getShow('drop_seed_name') : null;
    }
}

?>
