<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_EnemyObject
**/
class Sd_EnemyObject extends XoopsSimpleObject
{
    /**
     * Sd_EnemyObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_EnemyObject()
    {
        $this->initVar('enemy_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('enemy_name', XOBJ_DTYPE_STRING, '', false, 50);
        $this->initVar('attack_kind', XOBJ_DTYPE_INT, '', false);
        $this->initVar('position', XOBJ_DTYPE_INT, '', false);
        $this->initVar('regist_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_EnemyHandler
**/
class Sd_EnemyHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_enemy';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'enemy_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_EnemyObject';

    /**
     * Sd_EnemyHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_EnemyHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByName
     * 
     * @param   string  $name
     * 
     * @return  Sd_EnemyObject
    **/
    public function getByName(/*** string ***/ $name)
    {
        $cri = new Criteria('enemy_name',$name);
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
