<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Enemy_skillObject
**/
class Sd_Enemy_skillObject extends XoopsSimpleObject
{
    /**
     * Sd_Enemy_skillObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Enemy_skillObject()
    {
        $this->initVar('link_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('enemy_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('skill_name', XOBJ_DTYPE_STRING, '', false, 255);
    }
}

/**
 * Sd_Enemy_skillHandler
**/
class Sd_Enemy_skillHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_enemy_skill';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'link_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Enemy_skillObject';

    /**
     * Sd_Enemy_skillHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Enemy_skillHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByUnique
     * 
     * @param   int     $id
     * @param   string  $name
     * 
     * @return  Sd_Enemy_skill
    **/
    public function getByUnique(/*** int ***/ $id,/*** string ***/ $name)
    {
        $cri = new CriteriaCompo(new Criteria('enemy_id',$id));
        $cri->add(new Criteria('skill_name',$name));
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
