<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Map_spotObject
**/
class Sd_Map_spotObject extends XoopsSimpleObject
{
    /**
     * Sd_Map_spotObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Map_spotObject()
    {
        $this->initVar('spot_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('spot_name', XOBJ_DTYPE_STRING, '', false, 50);
        $this->initVar('description', XOBJ_DTYPE_TEXT, '', false);
        $this->initVar('update_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_Map_spotHandler
**/
class Sd_Map_spotHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_map_spot';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'spot_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Map_spotObject';

    /**
     * Sd_Map_spotHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Map_spotHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByName
     * 
     * @param   string  $name
     * 
     * @return  Sd_Map_spot
    **/
    public function getByName(/*** string ***/ $name)
    {
        $cri = new Criteria('spot_name',$name);
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
