<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_ACTIVE_ABILITY_SORT_KEY_ENO', 1);
define('SD_ACTIVE_ABILITY_SORT_KEY_SLOT', 2);
define('SD_ACTIVE_ABILITY_SORT_KEY_ABILITY_ID', 3);
define('SD_ACTIVE_ABILITY_SORT_KEY_DEFAULT', SD_ACTIVE_ABILITY_SORT_KEY_ENO);

/**
 * Sd_Active_abilityFilterForm
**/
class Sd_Active_abilityFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_ACTIVE_ABILITY_SORT_KEY_ENO => 'eno',
        SD_ACTIVE_ABILITY_SORT_KEY_SLOT => 'slot',
        SD_ACTIVE_ABILITY_SORT_KEY_ABILITY_ID => 'ability_id'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_ACTIVE_ABILITY_SORT_KEY_DEFAULT;
    }

    /**
     * getTotalItems
     * 
     * @param   int  &$total
     * 
     * @return  void
     * 
     * @protected
    **/
    function getTotalItems(&$total)
    {
        $total = $this->_mHandler->getEquipCharsCount($this->getCriteria());
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('eno')) !== null) {
            $this->mNavi->addExtra('eno', $value);
            $this->_mCriteria->add(new Criteria('eno', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('ability_name')) !== null) {
            $ext = array();
            foreach(explode(' ',mb_convert_kana($value,'as')) as $v)
            {
                if($v != null)
                {
                    $ext[] = $v;
                    $this->_mCriteria->add(new Criteria('ability_name',$v));
                }
            }
            $this->mNavi->addExtra('ability_name',implode(' ',$ext));
        }
    
        if(!$this->_mCriteria->hasChildElements())
        {
            $this->_mCriteria->add(new Criteria('ability_name','dummy'));
        }
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
