<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

if(!defined('SD_TRUST_PATH'))
{
    define('SD_TRUST_PATH',XOOPS_TRUST_PATH . '/modules/sd');
}

require_once SD_TRUST_PATH . '/class/SdUtils.class.php';

$root =& XCube_Root::getSingleton();
$root->mDelegateManager->add('Module.sd.Event.GetAssetManager','Sd_AssetPreload::getManager');
$root->mDelegateManager->add('Legacy_Utils.CreateModule','Sd_AssetPreload::getModule');
$root->mDelegateManager->add('Legacy_Utils.CreateBlockProcedure','Sd_AssetPreload::getBlock');
unset($root);


/**
 * Sd_AssetPreload
**/
class Sd_AssetPreload extends XCube_ActionFilter
{
    /**
     * getManager
     * 
     * @param   Sd_AssetManager  &$obj
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @private
    **/
    function getManager(&$obj,$dirname)
    {
        require_once SD_TRUST_PATH . '/class/AssetManager.class.php';
        $obj = Sd_AssetManager::getInstance($dirname);
    }

    /**
     * getModule
     * 
     * @param   Legacy_AbstractModule  &$obj
     * @param   XoopsModule  $module
     * 
     * @return  void
     * 
     * @private
    **/
    function getModule(&$obj,$module)
    {
        if($module->getInfo('trust_dirname') == 'sd')
        {
            require_once SD_TRUST_PATH . '/class/Module.class.php';
            $obj = new Sd_Module($module);
        }
    }

    /**
     * getBlock
     * 
     * @param   Legacy_AbstractBlockProcedure  &$obj
     * @param   XoopsBlock  $block
     * 
     * @return  void
     * 
     * @private
    **/
    function getBlock(&$obj,$block)
    {
        $moduleHandler =& Sd_Utils::getXoopsHandler('module');
        $module =& $moduleHandler->get($block->get('mid'));
        if(is_object($module) && $module->getInfo('trust_dirname') == 'sd')
        {
            require_once SD_TRUST_PATH . '/blocks/' . $block->get('func_file');
            $className = 'Sd_' . substr($block->get('show_func'), 4);
            $obj = new $className($block);
        }
    }
}

?>
